/*
 *		PICFX
 */
#include  <stdio.h>
#include  <stdlib.h>
#include  <stdint.h>
#include  <unistd.h>
#include  <string.h>
#include  <math.h>

#include  <floatimg.h>
#include  <tthimage.h>

#include  "picfx.h"

extern int		verbosity;

/* ------------------------------------------------------------------------ */
int init_the_bizness(char *wot)
{
int		foo;

#if DEBUG_LEVEL
fprintf(stderr, "---- initialisation (%s) ----\n\n", wot);
#endif

foo = Image_t16x24_txtload("16x24thin", NULL, 0);
if (foo) {
	fprintf(stderr, "%s: font 16x24 load -> %d\n", __func__, foo);	
	return -1;
	}
foo = Image_load_fnt8x8("8x8thin", NULL, 0);
if (foo) {
	fprintf(stderr, "%s: font 8x8 load -> %d\n", __func__, foo);	
	return -1;
	}
return 0;
}
/* ------------------------------------------------------------------------ */
/*
 *  nouveau 30 septembre 2022 - epuis, beaucoup d'hesitations, mais
 *  le 3 novembre, les affaires reprennent :)
 *
 */
int execute_la_morpho(FloatImg *pimg, int param)
{
FloatImg	ftmp;
int		foo;

#if DEBUG_LEVEL
fprintf(stderr, ">>> %s ( %p %d )\n", __func__, pimg, param);
#endif

fimg_save_as_pnm(pimg, "a.pnm", 0);		// TRACE

foo = fimg_clone(pimg, &ftmp, 0);
if (foo) {
	fprintf(stderr, "*** %s : err %d fimg_clone\n", __func__, foo);
	return foo;
	}
fimg_clear(&ftmp);

foo = fimg_filtre_morpho_0(pimg, &ftmp, param);
if (foo) {
	fprintf(stderr, "err %d in 'filtre_morpho'\n", foo);
	return -3;
	}
fimg_save_as_pnm(&ftmp, "b.pnm", 0);		// TRACE

foo = fimg_copy_data(&ftmp, pimg);
if (foo) {
	fprintf(stderr, "err %d in 'copy_data'\n", foo);
	return -3;
	}

fimg_destroy(&ftmp);

return 0;
}
/* ------------------------------------------------------------------------ */
int color_brotch_0(Image_Desc *pimg, int flag)
{
int			r, g, b;

Image_couleur_moyenne(pimg, &r, &g, &b);
Image_effect_x_0(pimg, pimg, b, g, r );
if (flag) printf("%d %d %d\n", r, g, b);

return 0;
}
/* ------------------------------------------------------------------------ */
int color_brotch_1(Image_Desc *pimg, int flag)
{
Image_Desc		*clone;
int			foo;

Image_egalise_mono_0(pimg, pimg, 0);

if (NULL==(clone=Image_clone(pimg, 1))) {
	fprintf(stderr, "%s err clone\n", __func__);
	abort();
	}

foo = Image_call_recursion_0(pimg, clone, 8);
if (foo) {
	;  // fprintf(stderr, "%s: recurse -> %d\n", __func__, foo);
	}

if (flag)	Image_copy(clone, pimg);
else 		Image_mix(pimg, clone, pimg, 5000);

Image_DeAllocate(clone);	free(clone);

return 0;
}
/* ------------------------------------------------------------------------ */
int ondulation_0(Image_Desc *pimg, int clock)
{
float			temps;
double			table[6];
Image_Desc		*clone;
int			foo;

#if DEBUG_LEVEL
fprintf(stderr, ">>> %s ( %p %d )\n", __func__, pimg, clock);
#endif

temps = (float)clock / FRAMERATE;
// fprintf(stderr, "real time : %5.2f secs\n", temps);

memset(table, 0, 6*sizeof(double));

table[0] = (double)temps * 0.51;
table[1] = 15.0;
table[4] = (double)temps * 0.42;

table[2] = 8.0;
table[3] = 4.04 * cos((double)temps);

if (NULL==(clone=Image_clone(pimg, 1))) {
	fprintf(stderr, "%s err clone\n", __func__);
	abort();
	}

foo = Image_2x2_contours_0(pimg);
if (foo) {
	fprintf(stderr, "%s: contour 2x2 -> %d\n", __func__, foo);
	return -2;
	}

foo = Image_2x2_lissage(pimg, pimg);
if (foo) {
	fprintf(stderr, "%s: lissage 2x2 -> %d\n", __func__, foo);
	return -2;
	}
foo = Image_2x2_lissage(pimg, pimg);
if (foo) {
	fprintf(stderr, "%s: lissage 2x2 -> %d\n", __func__, foo);
	return -2;
	}

foo = Image_sinwave_0(pimg, clone, table);
if (foo) {
	fprintf(stderr, "%s: sinwave 0 -> %d\n", __func__, foo);
	return -2;
	}

Image_copy(clone, pimg);	Image_DeAllocate(clone);	free(clone);

return 0;
}
/* ------------------------------------------------------------------------ */
int filtrage_0(Image_Desc *pimg, int clock)
{
Image_Desc		*cloneA, *cloneB;
int			foo, rotation;

if (NULL==(cloneA=Image_clone(pimg, 0))) {
	fprintf(stderr, "%s err clone A\n", __func__);
	abort();
	}
if (NULL==(cloneB=Image_clone(pimg, 0))) {
	fprintf(stderr, "%s err clone A\n", __func__);
	abort();
	}

rotation = 2;

foo = Image_filtre_Sobel(pimg, cloneA, rotation);
if (foo) {
	fprintf(stderr, "%s: Sobel -> %d\n", __func__, foo);
	return -2;
	}
foo = Image_filtre_passe_haut(pimg, cloneB);
if (foo) {
	fprintf(stderr, "%s: passe haut -> %d\n", __func__, foo);
	return -2;
	}

Image_to_gray(cloneA, cloneA, 1);

Image_combine_cercle_flou(cloneB, cloneA, pimg, 0);

Image_DeAllocate(cloneA);	free(cloneA);
Image_DeAllocate(cloneB);	free(cloneB);

return 0;
}
/* ------------------------------------------------------------------------ */
int fragmentation(Image_Desc *pimg, int clock)
{
Image_Desc		*cloneA, *cloneB;
int			foo;

if (NULL==(cloneA=Image_clone(pimg, 1))) {
	fprintf(stderr, "%s err clone a\n", __func__);
	abort();
	}
if (NULL==(cloneB=Image_clone(pimg, 1))) {
	fprintf(stderr, "%s err clone a\n", __func__);
	abort();
	}

foo = Image_pixeliz_0(pimg, cloneA, 36, 12);
foo = Image_to_gray(pimg, cloneB, 0);

Image_mix(cloneA, cloneB, pimg, 3200);

Image_DeAllocate(cloneA);	free(cloneA);
Image_DeAllocate(cloneB);	free(cloneB);

return -2;
}
/* ------------------------------------------------------------------------ */

int television_5(Image_Desc *pimg, int clock, int variant)
{
Image_Desc		*cloneA;

// fprintf(stderr, ">>> %s ( %p %5d %d )\n", __func__, pimg, clock, variant);

if (NULL==(cloneA=Image_clone(pimg, 1))) {
	fprintf(stderr, "%s err clone a\n", __func__);
	abort();
	}

switch (variant) {
	case 0:
		Image_TV_grink(pimg, cloneA, (clock>>2) & 1);		break;
	case 1:
		Image_TV_grok(pimg, cloneA, (clock>>4) & 1);		break;
	case 2:
		Image_TV_gruud(pimg, cloneA, 0);			break;
	case 3:
		Image_TV_old(pimg, cloneA, (clock/19)%2, 1+(clock%2), 2);
		Image_luminance(cloneA, cloneA, 550); 
		break;
	default:
		Image_TV_griiiz(pimg, cloneA, 0);			break;
	}

Image_copy(cloneA, pimg);
Image_DeAllocate(cloneA);	free(cloneA);

return -1;
}
/* ------------------------------------------------------------------------ */
int microscope_0(Image_Desc *pimg, int clock, int variant)
{
Image_Desc		*cloneA;
int			foo;
Image_Rect		zone;		
// fprintf(stderr, ">>> %s ( %p %5d %d )\n", __func__, pimg, clock, variant);

if (NULL==(cloneA=Image_clone(pimg, 0))) {
	fprintf(stderr, "%s err clone a\n", __func__);
	abort();
	}

/*
foo = Image_negate(pimg, pimg);
if (foo) {
	fprintf(stderr, "%s: negate -> %s\n", __func__,  Image_err2str(foo));
	}
*/

zone.x = 349;
zone.y = 257;
zone.w = 120;			zone.h = 178;
// Image_dump_rect(&zone, __func__, 0);

foo = Image_zoom_extract(pimg, cloneA, &zone, 1);
//if (foo) {
//	fprintf(stderr, "%s: essai zoom -> %s\n", __func__,  Image_err2str(foo));
//	}

Image_copy(cloneA, pimg);
Image_DeAllocate(cloneA);	free(cloneA);

return -1;
}
/* ------------------------------------------------------------------------ */

void picfx_version(int k)
{
fprintf(stderr, "=== %s / k=%d, v=%d    ", __func__, k, verbosity);
fprintf(stderr, "compiled %s at %s\n", __DATE__, __TIME__);
}
/* ------------------------------------------------------------------------ */
void print_versions(char *title)
{

if (NULL!=title) { fprintf(stderr, "-------------- %s --------------\n",
						   title); }
fimg_print_version(1);
Image_print_version(1);
picfx_version(5);
}
/* ------------------------------------------------------------------------ */

int add_some_text(Image_Desc *pimg, char *txt, int flag)
{
int			foo;
RGBA			paper, ink;

#if DEBUG_LEVEL > 1
fprintf(stderr, ">>> %s ( %p '%s' 0x%x )\n", __func__, pimg, txt, flag);
#endif

paper.r = paper.g = paper.b = 0;		paper.a = 0;
ink.r = ink.g = 202; ink.b = 242;		ink.a = 255;

foo = Image_t16x24_pltstr_1(pimg, txt, 20, pimg->height-30, &paper, &ink, 0);
if (foo) {
	fprintf(stderr, "%s: plot string -> %d = %s\n", __func__, foo,
					Image_err2str(foo));
	}

return 0;
}
/* ------------------------------------------------------------------------ */
